/*	TViewTypeForm.cpp
 *
 *		Project form management
 */

/*  YAAF Constructor - Rapid application development for YAAF
 *  Copyright (C) 1998 William Edward Woody
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *  
 *  To contact the author, either e-mail me at woody@pandawave.com, 
 *	or write to
 *  
 *          William Edward Woody
 *          In Phase Consulting
 *          1545 Ard Eevin Avenue
 *          Glendale, CA 91202
 *
 *	Or visit us on the web at http://www.pandawave.com
 */

#include <XWindow.h>
#include <XDocument.h>
#include <XMessages.h>
#include "TResDocument.h"
#include "TViewTypeList.h"
#include "TViewTypeForm.h"


/************************************************************************/
/*																		*/
/*	Construction/Destruction											*/
/*																		*/
/************************************************************************/

/*	TViewTypeForm::TViewTypeForm
 *
 *		Construct me. Doesn't do much
 */

TViewTypeForm::TViewTypeForm()
{
}

/*	TViewTypeForm::~TViewTypeForm
 *
 *		Destruct me. Doesn't do much
 */

TViewTypeForm::~TViewTypeForm()
{
	fViewType->window = NULL;
}

/*	TViewTypeForm::InitWindow
 *
 *		Intialize the window
 */

void TViewTypeForm::InitWindow(XGWindow *w, ViewTypeRecord *vt)
{
	XGDocument *doc;
	TViewTypeList *view;
	
	// Initialize view type pointer
	fViewType = vt;
	
	// Initialize window
	doc = w->GetDocument();
	doc->AttachWindow(w,true);
	SetWindowName(w);
	view = dynamic_cast<TViewTypeList *>(w->FindViewByID(2));
	doc->AddReceiver(view);
	view->SetFocus();
	view->InitEditor(vt);
}

/************************************************************************/
/*																		*/
/*	Events																*/
/*																		*/
/************************************************************************/

BEGINFORM(TViewTypeForm)
	DISPATCHFORM(KXGEventDocRenamed,TViewTypeForm::DoDocRenamed)
ENDFORM

/*	TViewTypeForm::DoDocRenamed
 *
 *		handle renaming this document by renaming this window
 */

long TViewTypeForm::DoDocRenamed(XGWindow *w, long, void *)
{
	SetWindowName(w);
	return 0;
}

/************************************************************************/
/*																		*/
/*	Internals															*/
/*																		*/
/************************************************************************/

/*	TViewTypeForm::SetWindowName
 *
 *		Set the name of this window based on the document's name
 */

void TViewTypeForm::SetWindowName(XGWindow *w)
{
	char buffer[256];
	char docname[256];
	XGDocument *doc;
	
	doc = w->GetDocument();
	if (doc) {
		doc->GetDocumentName(docname);
		sprintf(buffer,"%s: %s",docname,fViewType->className);
		w->SetTitle(buffer);
	}
}
